<template>
  <a-modal
    :title="title"
    :width="width"
    :visible="visible"
    :bodyStyle="bodyStyle"
    :confirmLoading="confirmLoading"
    :maskClosable="false"
    @ok="handleOk"
    @cancel="handleCancel"
    cancelText="关闭"
    :footer="null">
    <a-spin :spinning="confirmLoading">
      <a-form :form="form">


        <a-form-item label="企业名称" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input v-decorator="[ 'companyName', validatorRules.companyName]" placeholder="请输入企业名称" :disabled="true"></a-input>
        </a-form-item>

        <div>平台相关配置</div>

        <a-form-item label="服务费率" :labelCol="labelCol" :wrapperCol="wrapperCol">
        <a-input-number :min="0.01" :max="99.99" v-decorator="[ 'serviceFeeRate', validatorRules.serviceFeeRate]"
                        :formatter="value => `${value}%`" :parser="value => value.replace('%', '')"
                        placeholder="请输入服务费率"
                        style="width: 100%"/>
      </a-form-item>


        <a-form-item label="付款类型" :labelCol="labelCol" :wrapperCol="wrapperCol" :required="true">
          <j-dict-select-tag type="list" @change="changePaymentType"
                             v-decorator="['paymentType',validatorRules.paymentType]" :trigger-change="true"
                             dictCode="payment_type" placeholder="请选择企业合同方式" style="width: 100%"/>
        </a-form-item>

        <a-form-item label="企业合同" :labelCol="labelCol" :wrapperCol="wrapperCol" :required="true">
          <j-dict-select-tag type="list" @change="getcontractType"
                             v-decorator="['serviceContractType',validatorRules.serviceContractType]" :trigger-change="true"
                             dictCode="contract_type" placeholder="请选择企业合同方式" style="width: 100%"/>
        </a-form-item>

        <template v-if="model.serviceContractType=='0'">
          <a-form-item label="上传合同" :labelCol="labelCol" :wrapperCol="wrapperCol">
            <a-upload
              name="file"
              :accept="accept"
              :multiple="false"
              :action="uploadAction"
              :headers="headers"
              :data="{'isup':1,'bizPath':bizPath}"
              :fileList="fileList"
              :beforeUpload="beforeUpload"
              @change="handleChange">
              <a-button>
                <a-icon type="upload"/>
                {{ text }}
              </a-button>
              <span style="margin-left: 10px">请上传pdf格式</span>
            </a-upload>
          </a-form-item>
        </template>

        <a-form-item label="合同到期日" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <j-date placeholder="请选择合同到期日" v-decorator="[ 'serviceContractExpiryDate', validatorRules.serviceContractExpiryDate]" :trigger-change="true"
                  :show-time="true" date-format="YYYY-MM-DD" style="width: 100%"/>
        </a-form-item>

        <div>服务商相关配置</div>

        <a-form-item label="服务商" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <template v-if="!model.balance">
            <a-input-search
              placeholder="选择服务商"
              disabled
              v-decorator="[ 'subcontractorName',  {rules: [{ required: true, message: '请选择服务商' }],initialValue:model.subcontractorName}]"
              @search="onSearch">
              <a-button slot="enterButton" icon="search" v-if="!model.id">选择</a-button>
          </a-input-search>
          </template>
            <template v-else>
                  <a-input v-decorator="[ 'subcontractorName', {rules: [{ required: true, message: '请选择服务商' }],initialValue:model.subcontractorName}]"  :disabled="true"></a-input>
            </template>

        </a-form-item>

        <div>用户合同相关配置</div>
        <a-form-item label="用户合同" :labelCol="labelCol" :wrapperCol="wrapperCol" :required="true">
          <j-dict-select-tag  v-decorator="['workContractType', validatorRules.workContractType]" placeholder="请选择用户合同方式"  :type="'list'" @change="workContractType" :triggerChange="true" dictCode="workContractType"/>
        </a-form-item>

        <a-form-item label=" " :colon="false" :labelCol="labelCol" :wrapperCol="wrapperCol" >
          <a-checkbox-group :options="[{label:'自动生成订单',value:1},{label:'自动确认订单',value:2, disabled: confirmDisabled }]"  v-model="valueInfo" @change="onChange" />
        </a-form-item>


      </a-form>
    </a-spin>
    <div class="drawer-bootom-button">
      <a-button class="ant-btn"  @click="handleCancelOut">取消</a-button>
      <a-button class="ant-btn ant-btn-primary" style="margin-left: 8px"  @click="handleOkIn">确定</a-button>
    </div>
    <subcontractor-window ref="subcontractorWindow" @ok="modalFormOk"></subcontractor-window>
  </a-modal>

</template>

<script>
  import { httpAction } from '@/api/manage'
  import JDate from '@/components/jeecg/JDate'
  import JUpload from '@/components/jeecg/JUpload'
  import JSelectDepart from '@/components/jeecgbiz/JSelectDepart'
  import JDictSelectTag from '@/components/dict/JDictSelectTag'
  import Vue from 'vue'
  import { ACCESS_TOKEN } from '@/store/mutation-types'
  import { getAction, deleteAction, putAction, postAction,downFile } from '@/api/manage'
  import pick from 'lodash.pick'
  import SubcontractorWindow from './SubcontractorWindow'
  const editInfo = (params) => putAction('/saasmanager/hwPlatformCompany/editInfo', params)



  const FILE_TYPE_ALL = "all"
  const FILE_TYPE_PDF = 'pdf'
  const uidGenerator = () => {
    return '-' + parseInt(Math.random() * 10000 + 1, 10)
  }
  const getFileName = (path) => {
    if (path.lastIndexOf('\\') >= 0) {
      let reg = new RegExp('\\\\', 'g')
      path = path.replace(reg, '/')
    }
    return path.substring(path.lastIndexOf('/') + 1)
  }

  export default {
    name: 'HwPlatformCompanyInfodeplyModal',
    components: {
      SubcontractorWindow,
      JDate,
      JUpload,
      JSelectDepart,
      JDictSelectTag,
    },
    data() {
      return {
        selectedDepartKeys:[], //保存用户选择服务商id
        checkedDepartKeys:[],
        confirmDisabled:false,
        valueInfo:[],
        uploadAction: window._CONFIG['domianURL'] + '/hpSys/common/ossUpload',
        urlDownload: window._CONFIG['domianURL'] + '/hpSys/common/ossDownload',
        headers: {},
        fileList: [],
        fileList1: [],
        form: this.$form.createForm(this),
        title: '操作',
        width: 1000,
        bodyStyle: {
          paddingTop: '20px',
          paddingBottom:'50px',
          maxHeight: (window.innerHeight * 0.64) + 'px',
          'overflow-y': 'auto'
        },
        visible: false,
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 }
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 }
        },
        defaultFileList:[],
        accept:'.pdf',
        id:0,
        confirmLoading: false,
        validatorRules: {
          serviceContractType: { rules: [{ required: true, message: '请选择企业合同方式' }] },
          serviceFeeRate: { rules: [{ required: true, message: '请输入服务费率!' }] },
          subcontractorFeeRate: { rules: [{ required: true, message: '请输入外包服务费率!' }] },
          workContractType:{ rules: [{ required: true, message: '请选择用户合同方式' }] },
          paymentType:{ rules: [{ required: true, message: '请选择付款类型' }] },
          serviceContractExpiryDate:{ rules: [{ required: true, message: '请选择合同到期日' }] },
        },
        url: {
          fileUpload: window._CONFIG['domianURL'] + '/hpSys/common/ossUpload',
          edit: '/requiremanager/hwRequirement/edit',
          importExcelUrl: "requiremanager/hwRequirement/importExcel?id=",
          exportXlsUrl:"/requiremanager/hwRequirement/tyemplateGeneration",
          imgerver: window._CONFIG['imgDomainOssURL'],
        },
      }
    },
    props: {
      text: {
        type: String,
        required: false,
        default: '点击上传'
      },
      fileType: {
        type: String,
        required: false,
        default: FILE_TYPE_ALL
      },
      /*这个属性用于控制文件上传的业务路径*/
      bizPath: {
        type: String,
        required: false,
        default: '/hpwork/hwcompany'
      },
      value: {
        type: String,
        required: false
      },
      //此属性被废弃了
      triggerChange: {
        type: Boolean,
        required: false,
        default: false
      }
    },
    watch: {

    },
    created() {
      const token = Vue.ls.get(ACCESS_TOKEN)
      this.headers = { 'X-Access-Token': token }

    },
    methods: {
      add() {
        this.edit({})
      },
      edit(record) {
        this.form=this.$form.createForm(this)
        this.model={}
        this.valueInfo=[]
        this.form.resetFields()
        this.confirmDisabled=false
        this.model = Object.assign({}, record)
        console.log(11111,this.model.subcontractorFeeRate)
        this.id=record.id
        this.$nextTick(() => {
          this.form.setFieldsValue(pick(this.model, 'companyName','serviceFeeRate','paymentType','serviceContractType','serviceContract','serviceContractExpiryDate','workContractType','isAutoOrder','isAutoConfirm', 'subcontractorId','subcontractorName','balance'))
          this.form.setFieldsValue({ serviceContractType:this.model.serviceContractType!=null?String(this.model.serviceContractType):''})
          this.form.setFieldsValue({ workContractType:this.model.workContractType!=null?String(this.model.workContractType):''})
          this.form.setFieldsValue({ paymentType:this.model.paymentType!=null?String(this.model.paymentType):''})
          this.form.setFieldsValue({ serviceContractExpiryDate:this.model.serviceContractExpiryDate?String(this.model.serviceContractExpiryDate).substring(0,10):null})
          this.model.serviceContractExpiryDate=String(this.model.serviceContractExpiryDate).substring(0,10)
        })
        this.editFileList(this.model.serviceContract)
        if(this.model.isAutoOrder==1){
          this.valueInfo.push(1)
        }
        if(this.model.isAutoConfirm==1){
          this.valueInfo.push(2)
        }
        if(this.model.workContractType==2){
          this.confirmDisabled=true
          if(this.model.isAutoOrder==1){
            this.valueInfo=[1]
          }else{
            this.valueInfo=[]
          }
        }


        this.visible = true
      },




      close() {
        this.$emit('ok')
        this.visible = false
      },
      handleOk(){
        this.close()
      },
      handleOkIn() {


        this.form.validateFields((err, values) => {
          if (!err) {
            let formData = Object.assign(this.model, values)
            formData.serviceContract=this.model.serviceContractType!=0?null: formData.serviceContract
            formData.subcontract=this.model.subcontractType!=0?null: formData.subcontract
            formData.serviceContractExpiryDate=this.model.serviceContractExpiryDate+" 23:59:59"
            if(this.selectedDepartKeys[0]){
              formData.subcontractorId = this.selectedDepartKeys[0];
            }
            editInfo(formData).then((res) => {
              if (res.success) {
                this.$message.success(res.message)
                this.$emit('ok')
                this.visible = false
              } else {
                this.$message.warning(res.message)
              }
            })
          }
        })
      },
      handleCancel(){
        this.visible = false
      },
      handleCancelOut() {
      this.close()
      },
      popupCallback(row) {
        this.form.setFieldsValue(pick(row,'subcontractType','subcontract'))
      },
      onChangeMenuType(e) {
        this.model.subcontractType=null
      },
      selectSubcontractType(e){
        if(e!=null && e!=''){
          this.form.setFieldsValue({ subcontractType:e})
        }
        var subcontractType = this.form.getFieldValue('subcontractType');
        this.model.subcontractType=subcontractType==''?null:subcontractType
      },
      workContractType(e){
        if(e!=null && e!=''){
          this.form.setFieldsValue({ workContractType:e})
        }
        var workContractType = this.form.getFieldValue('workContractType');
        this.model.workContractType=workContractType==''?null:workContractType
        if(this.model.workContractType==2){
          this.confirmDisabled=true
          if(this.model.isAutoOrder==1){
            this.valueInfo=[1]
          }else{
            this.valueInfo=[]
          }
          this.model.isAutoConfirm=0
        }else{
          this.confirmDisabled=false
        }
      },

      handlePathChange() {
        let uploadFiles = this.fileList
        let path = ''
        if (!uploadFiles || uploadFiles.length == 0) {
          path = ''
        }
        let arr = []

        for (var a = 0; a < uploadFiles.length; a++) {
          arr.push(uploadFiles[a].response.message)
        }
        if (arr.length > 0) {
          path = arr.join(',')
        }
        this.$emit('change', path)
        console.log(1111,this.fileList)
      },
      beforeUpload(file) {
        if (this.fileList.length>=1) {
          this.$message.warning('只能上传一个文件')
          return false
        }
      },
      handleChange(info) {
        if (info.fileList.length>1) {
          return false
        }
        var fileType =info.file.type
        if(fileType){
          if (fileType.indexOf(FILE_TYPE_PDF)<0) {
            this.$message.warning('请上传pdf文件')
            return false
          }
        }
        console.log('--文件列表改变--')
        let fileList = info.fileList
        if (info.file.status === 'done') {
          if (info.file.response.success) {
            fileList = fileList.map((file) => {
              if (file.response) {
                // file.url = this.urlDownload+file.response.message;
                this.model.serviceContract = file.response.message
              }
              return file
            })
          }
          this.$message.success(`${info.file.name} 上传成功!`)
        } else if (info.file.status === 'error') {
          this.$message.error(`${info.file.name} 上传失败.`)
        } else if (info.file.status === 'removed') {
          this.handleDelete(info.file)
        }
        this.fileList = fileList
        if (info.file.status === 'done' || info.file.status === 'removed') {
          this.handlePathChange()
        }
      },
      handleDelete(file) {
        //如有需要新增 删除逻辑
        console.log(file)
        this.fileList = [];
      },
      getcontractType(val) {
        this.model.serviceContractType = val==''?null:val
      },
      changePaymentType(val){
        this.model.paymentType = val==''?null:val
      },
      //回显文件所用
      editFileList(paths) {
        if (!paths || paths.length == 0) {
          //return [];
          // update-begin- --- author:os_chengtgen ------ date:20190729 ---- for:issues:326,Jupload组件初始化bug
          this.fileList = []
          return
          // update-end- --- author:os_chengtgen ------ date:20190729 ---- for:issues:326,Jupload组件初始化bug
        }
        let fileList = []
        let arr = paths.split(',')
        for (var a = 0; a < arr.length; a++) {
          fileList.push({
            uid: uidGenerator(),
            name: getFileName(arr[a]),
            status: 'done',
            url: this.url.imgerver +  arr[a],
            thUrl: arr[a]
          })
        }
        this.fileList = fileList
      },




      onChange(checkedValues){
        this.model.isAutoOrder=0
        this.model.isAutoConfirm=0
        if(checkedValues.length>0){
          for (let i = 0; i <checkedValues.length ; i++) {
             if(checkedValues[i]==1){
               this.model.isAutoOrder=1
             }
             if(checkedValues[i]==2){
               this.model.isAutoConfirm=1
             }
          }
        }
      },

      //搜索服务商
      onSearch(){
        this.$refs.subcontractorWindow.add(this.checkedDepartKeys);
      },
      // 获取用户选择服务商弹提交的返回数据
      modalFormOk (formData) {
        this.selectedDepartKeys = [];
        for (let i = 0; i < formData.departIdList.length; i++) {
          this.selectedDepartKeys.push(formData.departIdList[i].key);
          this.form.setFieldsValue({ subcontractorName: formData.departIdList[i].title })
        }
        this.checkedDepartKeys = this.selectedDepartKeys  //更新当前的选择keys
      },


    }
  }
</script>
<style>
  .drawer-bootom-button {
    position: absolute;
    bottom: -8px;
    width: 100%;
    border-top: 1px solid #e8e8e8;
    padding: 10px 16px;
    text-align: right;
    left: 0;
    background: #fff;
    border-radius: 0 0 2px 2px;
  }

  .ant-upload{
    display: flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
  }
</style>